/******************************************************************************
*                                                                             *
*    Bmp2Icon.c                             Copyright(c) 2005-2007 itow,y.    *
*                                                                             *
******************************************************************************/


#include <windows.h>
#include <commctrl.h>
#include <shlwapi.h>
#include <tchar.h>
#include "../IconTools.h"
#include "resource.h"


HINSTANCE hInst;
BOOL fUseTransColor=FALSE;




/*
	EBhEfXNgbv̒Ɉړ
*/
void MoveWindowToCenter(HWND hwnd)
{
	RECT rcWindow,rcWork;

	GetWindowRect(hwnd,&rcWindow);
	OffsetRect(&rcWindow,-rcWindow.left,-rcWindow.top);
	SystemParametersInfo(SPI_GETWORKAREA,0,&rcWork,0);
	MoveWindow(hwnd,rcWork.left+((rcWork.right-rcWork.left)-rcWindow.right)/2,
					rcWork.top+((rcWork.bottom-rcWork.top)-rcWindow.bottom)/2,
										rcWindow.right,rcWindow.bottom,TRUE);
}


/*
	BMPt@Cǂݍ
*/
BOOL LoadBmpFile(HWND hwnd,LPCTSTR pszFileName,BITMAPINFO **ppbmi)
{
	HANDLE hFile;
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	DWORD dwRead;
	SIZE_T DataBytes;

	hFile=CreateFile(pszFileName,GENERIC_READ,FILE_SHARE_READ,NULL,
									OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) {
		MessageBox(hwnd,TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!ReadFile(hFile,&bmfh,sizeof(BITMAPFILEHEADER),&dwRead,NULL)
										|| dwRead!=sizeof(BITMAPFILEHEADER)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (bmfh.bfType!=0x4D42) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("rbg}bvt@Cł͂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!ReadFile(hFile,&bmih,sizeof(BITMAPINFOHEADER),&dwRead,NULL)
										|| dwRead!=sizeof(BITMAPINFOHEADER)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (bmih.biSize!=sizeof(BITMAPINFOHEADER)
			|| bmih.biHeight<=0
			|| (bmih.biBitCount!=1 && bmih.biBitCount!=4 && bmih.biBitCount!=8
					&& bmih.biBitCount!=24 && bmih.biBitCount!=32)
			|| bmih.biCompression!=BI_RGB) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("ΉĂȂ`łB"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	DataBytes=DIB_ROW_BYTES(bmih.biWidth,bmih.biBitCount)*bmih.biHeight;
	if (bmih.biBitCount<=8)
		DataBytes+=(1<<bmih.biBitCount)*sizeof(RGBQUAD);
	*ppbmi=(BITMAPINFO*)MemAlloc(sizeof(BITMAPINFOHEADER)+DataBytes);
	if (*ppbmi==NULL) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("mۂł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	(*ppbmi)->bmiHeader=bmih;
	if (!ReadFile(hFile,(BYTE*)*ppbmi+sizeof(BITMAPINFOHEADER),DataBytes,
										&dwRead,NULL)|| dwRead!=DataBytes) {
		MemFree(*ppbmi);
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	CloseHandle(hFile);
	return TRUE;
}


void SetMaskBits(const BITMAPINFO *pbmi,void *pBits,void *pMaskBits,
														COLORREF crTransparent)
{
	BYTE *p,*q;
	int x,y;
	SIZE_T RowBytes=
			DIB_ROW_BYTES(pbmi->bmiHeader.biWidth,pbmi->bmiHeader.biBitCount);
	SIZE_T MaskRowBytes=DIB_ROW_BYTES(pbmi->bmiHeader.biWidth,1);
	int TransIndex;

	if (pbmi->bmiHeader.biBitCount<=8)
		TransIndex=crTransparent;
	switch (pbmi->bmiHeader.biBitCount) {
	case 1:
		for (y=0;y<pbmi->bmiHeader.biHeight;y++) {
			p=(BYTE*)pBits+y*RowBytes;
			q=(BYTE*)pMaskBits+y*MaskRowBytes;
			for (x=0;x<pbmi->bmiHeader.biWidth;x++) {
				if (((p[x/8]>>(x&7))&1)==TransIndex)
					q[x/8]|=0x80>>(x&7);
			}
		}
		break;
	case 4:
		for (y=0;y<pbmi->bmiHeader.biHeight;y++) {
			p=(BYTE*)pBits+y*RowBytes;
			q=(BYTE*)pMaskBits+y*MaskRowBytes;
			for (x=0;x<pbmi->bmiHeader.biWidth;x++) {
				if (*p>>4==TransIndex)
					q[x/8]|=0x80>>(x&7);
				if (++x==pbmi->bmiHeader.biWidth)
					break;
				if ((*p&0x0F)==TransIndex)
					q[x/8]|=0x80>>(x&7);
				p++;
			}
		}
		break;
	case 8:
		for (y=0;y<pbmi->bmiHeader.biHeight;y++) {
			p=(BYTE*)pBits+y*RowBytes;
			q=(BYTE*)pMaskBits+y*MaskRowBytes;
			for (x=0;x<pbmi->bmiHeader.biWidth;x++) {
				if (*p==TransIndex)
					q[x/8]|=0x80>>(x&7);
				p++;
			}
		}
		break;
	case 24:
		{
			BYTE r,g,b;

			r=GetRValue(crTransparent);
			g=GetGValue(crTransparent);
			b=GetBValue(crTransparent);
			for (y=0;y<pbmi->bmiHeader.biHeight;y++) {
				p=(BYTE*)pBits+y*RowBytes;
				q=(BYTE*)pMaskBits+y*MaskRowBytes;
				for (x=0;x<pbmi->bmiHeader.biWidth;x++) {
					if (p[0]==b && p[1]==g && p[2]==r) {
						p[0]=0;
						p[1]=0;
						p[2]=0;
						q[x/8]|=0x80>>(x&7);
					}
					p+=3;
				}
			}
		}
		break;
	case 32:
		{
			BYTE r,g,b;

			r=GetRValue(crTransparent);
			g=GetGValue(crTransparent);
			b=GetBValue(crTransparent);
			for (y=0;y<pbmi->bmiHeader.biHeight;y++) {
				p=(BYTE*)pBits+y*RowBytes;
				q=(BYTE*)pMaskBits+y*MaskRowBytes;
				for (x=0;x<pbmi->bmiHeader.biWidth;x++) {
					if (p[0]==b && p[1]==g && p[2]==r)
						q[x/8]|=0x80>>(x&7);
					p+=4;
				}
			}
		}
		break;
	}
}


/*
	ACRt@Cɕۑ
*/
BOOL SaveIconFile(HWND hwnd,LPCTSTR pszFileName,const BITMAPINFO *pbmi,
														COLORREF crTransparent)
{
	HANDLE hFile;
	ICONDIR id;
	ICONDIRENTRY ide;
	DWORD dwWrite;
	SIZE_T PalBytes,BitsBytes,MaskBytes;
	BITMAPINFOHEADER bmih;
	void *pMaskBits;

	hFile=CreateFile(pszFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,
									CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) {
		MessageBox(hwnd,TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	id.idReserved=0;
	id.idType=1;
	id.idCount=1;
	if (!WriteFile(hFile,&id,sizeof(ICONDIR),&dwWrite,NULL)
												|| dwWrite!=sizeof(ICONDIR)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (pbmi->bmiHeader.biBitCount<=8)
		PalBytes=(1<<pbmi->bmiHeader.biBitCount)*sizeof(RGBQUAD);
	else
		PalBytes=0;
	BitsBytes=DIB_ROW_BYTES(pbmi->bmiHeader.biWidth,
						pbmi->bmiHeader.biBitCount)*pbmi->bmiHeader.biHeight;
	MaskBytes=DIB_ROW_BYTES(pbmi->bmiHeader.biWidth,1)*
													pbmi->bmiHeader.biHeight;
	ide.bWidth=pbmi->bmiHeader.biWidth<256?pbmi->bmiHeader.biWidth:0;
	ide.bHeight=pbmi->bmiHeader.biHeight<256?pbmi->bmiHeader.biHeight:0;
	ide.bColorCount=pbmi->bmiHeader.biBitCount<8?
											1<<pbmi->bmiHeader.biBitCount:0;
	ide.bReserved=0;
	ide.wPlanes=1;
	ide.wBitCount=pbmi->bmiHeader.biBitCount;
	ide.dwBytesInRes=sizeof(BITMAPINFOHEADER)+PalBytes+BitsBytes+MaskBytes;
	ide.dwImageOffset=sizeof(ICONDIR)+sizeof(ICONDIRENTRY);
	if (!WriteFile(hFile,&ide,sizeof(ICONDIRENTRY),&dwWrite,NULL)
											|| dwWrite!=sizeof(ICONDIRENTRY)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	bmih.biSize=sizeof(BITMAPINFOHEADER);
	bmih.biWidth=pbmi->bmiHeader.biWidth;
	bmih.biHeight=pbmi->bmiHeader.biHeight*2;
	bmih.biPlanes=1;
	bmih.biBitCount=pbmi->bmiHeader.biBitCount;
	bmih.biCompression=BI_RGB;
	bmih.biSizeImage=0;
	bmih.biXPelsPerMeter=0;
	bmih.biYPelsPerMeter=0;
	bmih.biClrUsed=0;
	bmih.biClrImportant=0;
	if (!WriteFile(hFile,&bmih,sizeof(BITMAPINFOHEADER),&dwWrite,NULL)
										|| dwWrite!=sizeof(BITMAPINFOHEADER)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	pMaskBits=MemAlloc(MaskBytes);
	if (pMaskBits==NULL) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("mۂł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	ZeroMemory(pMaskBits,MaskBytes);
	if (crTransparent!=CLR_INVALID) {
		void *pBits,*pSrcBits;

		pSrcBits=(BYTE*)pbmi+sizeof(BITMAPINFOHEADER)+PalBytes;
		if (pbmi->bmiHeader.biBitCount<=8) {
			RGBQUAD rgb[256];

			CopyMemory(rgb,pbmi->bmiColors,PalBytes);
			rgb[crTransparent].rgbBlue=0;
			rgb[crTransparent].rgbGreen=0;
			rgb[crTransparent].rgbRed=0;
			if (!WriteFile(hFile,rgb,PalBytes,&dwWrite,NULL)
														|| dwWrite!=PalBytes) {
				MemFree(pMaskBits);
				CloseHandle(hFile);
				MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
				return FALSE;
			}
			pBits=pSrcBits;
		} else {
			pBits=MemAlloc(BitsBytes);
			if (pBits==NULL) {
				MemFree(pMaskBits);
				CloseHandle(hFile);
				MessageBox(hwnd,TEXT("mۂł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
				return FALSE;
			}
			CopyMemory(pBits,pSrcBits,BitsBytes);
		}
		SetMaskBits(pbmi,pBits,pMaskBits,crTransparent);
		if (!WriteFile(hFile,pBits,BitsBytes,&dwWrite,NULL)
													|| dwWrite!=BitsBytes) {
			if (pBits!=pSrcBits)
				MemFree(pBits);
			MemFree(pMaskBits);
			CloseHandle(hFile);
			MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
			return FALSE;
		}
		if (pBits!=pSrcBits)
			MemFree(pBits);
	} else {
		if (!WriteFile(hFile,(BYTE*)pbmi+sizeof(BITMAPINFOHEADER),
											PalBytes+BitsBytes,&dwWrite,NULL)
											|| dwWrite!=PalBytes+BitsBytes) {
			MemFree(pMaskBits);
			CloseHandle(hFile);
			MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
			return FALSE;
		}
	}
	if (!WriteFile(hFile,pMaskBits,MaskBytes,&dwWrite,NULL)
													|| dwWrite!=MaskBytes) {
		MemFree(pMaskBits);
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	MemFree(pMaskBits);
	CloseHandle(hFile);
	return TRUE;
}


void SetNewIcon(HWND hDlg,LPCTSTR pszFileName,const BITMAPINFO *pbmi)
{
	BOOL fTrans=IsDlgButtonChecked(hDlg,IDC_USETRANSCOLOR)==BST_CHECKED;

	SetDlgItemText(hDlg,IDC_BMPFILE,pszFileName);
	InvalidateRect(GetDlgItem(hDlg,IDC_PREVIEW),NULL,TRUE);
	if (pbmi->bmiHeader.biBitCount<=8)
		SendDlgItemMessage(hDlg,IDC_TRANSCOLOR_INDEX_UD,UDM_SETRANGE,0,
							MAKELPARAM((1<<pbmi->bmiHeader.biBitCount)-1,0));
	InvalidateRect(GetDlgItem(hDlg,IDC_TRANSCOLOR),NULL,TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_TRANSCOLOR_INDEX),
									fTrans && pbmi->bmiHeader.biBitCount<=8);
	EnableWindow(GetDlgItem(hDlg,IDC_TRANSCOLOR_INDEX_UD),
									fTrans && pbmi->bmiHeader.biBitCount<=8);
}


BOOL ChooseColorDialog(HWND hwndOwner,COLORREF *pcrResult)
{
	static COLORREF crCustomColors[16]={
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF)
	};
	CHOOSECOLOR cc;

	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.hwndOwner=hwndOwner;
	cc.hInstance=NULL;
	cc.rgbResult=*pcrResult;
	cc.lpCustColors=crCustomColors;
	cc.Flags=CC_RGBINIT;
	if (!ChooseColor(&cc))
		return FALSE;
	*pcrResult=cc.rgbResult;
	return TRUE;
}


BOOL CALLBACK MainDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static BITMAPINFO *pbmiSource=NULL;
	static COLORREF crTransColor24=RGB(0,255,0);

	switch (uMsg) {
	case WM_INITDIALOG:
		{
			LPCTSTR pszCmdLine=(LPCTSTR)lParam,p;
			HICON hico;

			hico=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
			SendMessage(hDlg,WM_SETICON,ICON_BIG,(LPARAM)hico);
			if (pszCmdLine[0]!='\0') {
				TCHAR szFileName[MAX_PATH];
				TCHAR Delimiter;
				int i;
				BITMAPINFO *pbmi;

				p=pszCmdLine;
				if (*p=='"') {
					Delimiter='"';
					p++;
				} else
					Delimiter=' ';
				for (i=0;*p!=Delimiter && *p!='\0' && i<MAX_PATH;i++) {
#ifndef UNICODE
					if (IsDBCSLeadByteEx(CP_ACP,*p)) {
						if (i+1==MAX_PATH) {
							i++;
							break;
						}
						szFileName[i++]=*p++;
					}
#endif
					szFileName[i]=*p++;
				}
				if (i<MAX_PATH) {
					szFileName[i]='\0';
					GetLongPathName(szFileName,szFileName,MAX_PATH);
					if (LoadBmpFile(hDlg,szFileName,&pbmi)) {
						EnableWindow(GetDlgItem(hDlg,IDC_SAVE),TRUE);
						pbmiSource=pbmi;
						SetNewIcon(hDlg,szFileName,pbmiSource);
					}
				}
			}
			CheckDlgButton(hDlg,IDC_USETRANSCOLOR,
									fUseTransColor?BST_CHECKED:BST_UNCHECKED);
			MoveWindowToCenter(hDlg);
		}
		return TRUE;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;

			if (pdis->CtlID==IDC_PREVIEW) {
				if (pbmiSource!=NULL) {
					BYTE *pbBits=(BYTE*)pbmiSource+sizeof(BITMAPINFOHEADER);
					HBRUSH hbr;

					hbr=CreateSolidBrush(GetSysColor(COLOR_3DFACE));
					FillRect(pdis->hDC,&pdis->rcItem,hbr);
					DeleteObject(hbr);
					if (pbmiSource->bmiHeader.biBitCount<=8)
						pbBits+=(1<<pbmiSource->bmiHeader.biBitCount)*
															sizeof(RGBQUAD);
					SetDIBitsToDevice(pdis->hDC,
							((pdis->rcItem.right-pdis->rcItem.left)-
											pbmiSource->bmiHeader.biWidth)/2,
							((pdis->rcItem.bottom-pdis->rcItem.top)-
											pbmiSource->bmiHeader.biHeight)/2,
							pbmiSource->bmiHeader.biWidth,
							pbmiSource->bmiHeader.biHeight,0,0,0,
							pbmiSource->bmiHeader.biHeight,pbBits,pbmiSource,
															DIB_RGB_COLORS);
				}
			} else {
				COLORREF cr;
				HBRUSH hbr;

				cr=GetSysColor(COLOR_3DFACE);
				if (pbmiSource!=NULL) {
					if (pbmiSource->bmiHeader.biBitCount<=8) {
						int Index=GetDlgItemInt(hDlg,IDC_TRANSCOLOR_INDEX,NULL,
																		TRUE);

						if (Index>=0
								&& Index<1<<pbmiSource->bmiHeader.biBitCount)
							cr=RGB(pbmiSource->bmiColors[Index].rgbRed,
									pbmiSource->bmiColors[Index].rgbGreen,
									pbmiSource->bmiColors[Index].rgbBlue);
					} else
						cr=crTransColor24;
				}
				hbr=CreateSolidBrush(cr);
				FillRect(pdis->hDC,&pdis->rcItem,hbr);
				DeleteObject(hbr);
			}
		}
		return TRUE;

	case WM_DROPFILES:
		{
			TCHAR szFileName[MAX_PATH];
			BITMAPINFO *pbmi;

			SetForegroundWindow(hDlg);
			DragQueryFile((HDROP)wParam,0,szFileName,MAX_PATH);
			if (LoadBmpFile(hDlg,szFileName,&pbmi)) {
				if (pbmiSource!=NULL)
					MemFree(pbmiSource);
				else
					EnableWindow(GetDlgItem(hDlg,IDC_SAVE),TRUE);
				pbmiSource=pbmi;
				SetNewIcon(hDlg,szFileName,pbmiSource);
			}
			DragFinish((HDROP)wParam);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BROWSEBMPFILE:
			{
				OPENFILENAME ofn;
				TCHAR szText[MAX_PATH],szFileName[MAX_PATH];

				GetDlgItemText(hDlg,IDC_BMPFILE,szText,MAX_PATH);
				if (szText[0]!='\0')
					lstrcpy(szFileName,PathFindFileName(szText));
				else
					szFileName[0]='\0';
#if _WIN32_WINNT>=0x0500
				ofn.lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
				ofn.lStructSize=sizeof(OPENFILENAME);
#endif
				ofn.hwndOwner=hDlg;
				ofn.lpstrFilter=TEXT("BMPt@C(*.bmp)\0*.bmp\0"
												"SẴt@C(*.*)\0*.*\0");
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=MAX_PATH;
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=TEXT("ϊt@C");
				ofn.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
				ofn.lpstrDefExt=NULL;
				if (GetOpenFileName(&ofn)) {
					BITMAPINFO *pbmi;

					if (LoadBmpFile(hDlg,szFileName,&pbmi)) {
						if (pbmiSource!=NULL)
							MemFree(pbmiSource);
						else
							EnableWindow(GetDlgItem(hDlg,IDC_SAVE),TRUE);
						pbmiSource=pbmi;
						SetNewIcon(hDlg,szFileName,pbmiSource);
					}
				}
			}
			return TRUE;

		case IDC_USETRANSCOLOR:
			{
				BOOL fEnable=
					IsDlgButtonChecked(hDlg,IDC_USETRANSCOLOR)==BST_CHECKED
					&& pbmiSource!=NULL && pbmiSource->bmiHeader.biBitCount<=8;

				EnableWindow(GetDlgItem(hDlg,IDC_TRANSCOLOR_INDEX),fEnable);
				EnableWindow(GetDlgItem(hDlg,IDC_TRANSCOLOR_INDEX_UD),fEnable);
			}
			return TRUE;

		case IDC_TRANSCOLOR:
			if (pbmiSource!=NULL && HIWORD(wParam)==STN_CLICKED) {
				if (ChooseColorDialog(hDlg,&crTransColor24)) {
					if (pbmiSource->bmiHeader.biBitCount<=8) {
						int i,Colors=1<<pbmiSource->bmiHeader.biBitCount;
						int r,g,b;
						int Min,MinIndex,DistR,DistG,DistB,Dist;

						r=GetRValue(crTransColor24);
						g=GetGValue(crTransColor24);
						b=GetBValue(crTransColor24);
						Min=0x7FFFFFFF;
						for (i=0;i<Colors;i++) {
							DistR=pbmiSource->bmiColors[i].rgbRed-r;
							DistG=pbmiSource->bmiColors[i].rgbGreen-g;
							DistB=pbmiSource->bmiColors[i].rgbBlue-b;
							Dist=DistR*DistR+DistG*DistG+DistB*DistB;
							if (Dist<Min) {
								MinIndex=i;
								if (Dist==0)
									break;
								Min=Dist;
							}
						}
						SetDlgItemInt(hDlg,IDC_TRANSCOLOR_INDEX,MinIndex,TRUE);
					}
					InvalidateRect(GetDlgItem(hDlg,IDC_TRANSCOLOR),NULL,TRUE);
				}
			}
			return TRUE;

		case IDC_TRANSCOLOR_INDEX:
			if (HIWORD(wParam)==EN_CHANGE && pbmiSource!=NULL
										&& pbmiSource->bmiHeader.biBitCount<=8)
				InvalidateRect(GetDlgItem(hDlg,IDC_TRANSCOLOR),NULL,TRUE);
			return TRUE;

		case IDC_SAVE:
			{
				TCHAR szBmpFileName[MAX_PATH],szFileName[MAX_PATH];
				OPENFILENAME ofn;

				GetDlgItemText(hDlg,IDC_BMPFILE,szBmpFileName,MAX_PATH);
				lstrcpy(szFileName,PathFindFileName(szBmpFileName));
				PathRemoveExtension(szFileName);
#if _WIN32_WINNT>=0x0500
				ofn.lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
				ofn.lStructSize=sizeof(OPENFILENAME);
#endif
				ofn.hwndOwner=hDlg;
				ofn.lpstrFilter=TEXT("ICONt@C(*.ico)\0*.ico\0"
												"SẴt@C(*.*)\0*.*\0");
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=MAX_PATH;
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=NULL;
				ofn.Flags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
				ofn.lpstrDefExt=TEXT("ico");
				if (GetSaveFileName(&ofn)) {
					HCURSOR hcurOld;
					COLORREF crTrans;

					fUseTransColor=IsDlgButtonChecked(hDlg,IDC_USETRANSCOLOR)==
																BST_CHECKED;
					if (fUseTransColor) {
						if (pbmiSource->bmiHeader.biBitCount<=8) {
							int Index=
								GetDlgItemInt(hDlg,IDC_TRANSCOLOR_INDEX,NULL,
																		TRUE);

							if (Index<0
									|| Index>=
										1<<pbmiSource->bmiHeader.biBitCount) {
								MessageBox(hDlg,
											TEXT("ߐF̎w肪słB"),
											NULL,MB_OK | MB_ICONEXCLAMATION);
								return TRUE;
							}
							crTrans=Index;
						} else
							crTrans=crTransColor24;
					} else
						crTrans=CLR_INVALID;
					hcurOld=SetCursor(LoadCursor(NULL,IDC_WAIT));
					SaveIconFile(hDlg,szFileName,pbmiSource,crTrans);
					SetCursor(hcurOld);
				}
			}
			return TRUE;

		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
		}
		return TRUE;

	case WM_DESTROY:
		if (pbmiSource!=NULL)
			MemFree(pbmiSource);
		return TRUE;
	}
	return FALSE;
}


#ifdef __BORLANDC__
#pragma argsused
#endif
int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
												LPTSTR pszCmdLine,int nCmdShow)
{
	/* ϐ̏ */
	hInst=hInstance;

	/* RRg[̏ */
#if _WIN32_IE<0x0300
	InitCommonControls();
#else
	{
		INITCOMMONCONTROLSEX icc;

		icc.dwSize=sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC=ICC_UPDOWN_CLASS;
		InitCommonControlsEx(&icc);
	}
#endif

	/* _CAO̕\ */
	DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_MAIN),NULL,MainDlgProc,
														(LPARAM)pszCmdLine);

	return 0;
}
