/******************************************************************************
*                                                                             *
*    IconPlus.c                             Copyright(c) 2005-2007 itow,y.    *
*                                                                             *
******************************************************************************/


#include <windows.h>
#include <shlwapi.h>
#include <tchar.h>
#include "../IconTools.h"
#include "resource.h"


typedef enum {
	ICON_TYPE_UNKNOWN,
	ICON_TYPE_BIG,
	ICON_TYPE_SMALL
} IconType;

#include <pshpack1.h>

typedef struct {
	BITMAPINFOHEADER bmiHeader;
	RGBQUAD bmiColors[256];
} BITMAPINFO8;

#include <poppack.h>


HINSTANCE hInst;
const LPCTSTR pszFileFilter=
				TEXT("ICONt@C(*.ico)\0*.ico\0SẴt@C(*.*)\0*.*\0");




/*
	EBhEfXNgbv̒Ɉړ
*/
void MoveWindowToCenter(HWND hwnd)
{
	RECT rcWindow,rcWork;

	GetWindowRect(hwnd,&rcWindow);
	OffsetRect(&rcWindow,-rcWindow.left,-rcWindow.top);
	SystemParametersInfo(SPI_GETWORKAREA,0,&rcWork,0);
	MoveWindow(hwnd,rcWork.left+((rcWork.right-rcWork.left)-rcWindow.right)/2,
					rcWork.top+((rcWork.bottom-rcWork.top)-rcWindow.bottom)/2,
										rcWindow.right,rcWindow.bottom,TRUE);
}


/*
	t@CACRǂݍ
*/
BOOL LoadIconFile(HWND hwnd,LPCTSTR pszFileName,IconType Type,
															BITMAPINFO **ppbmi)
{
	HANDLE hFile;
	DWORD dwRead;
	ICONDIR id;
	ICONDIRENTRY ide;
	int i;
	SIZE_T DataSize;

	hFile=CreateFile(pszFileName,GENERIC_READ,FILE_SHARE_READ,NULL,
									OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) {
		MessageBox(hwnd,TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!ReadFile(hFile,&id,sizeof(ICONDIR),&dwRead,NULL)
												|| dwRead!=sizeof(ICONDIR)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (id.idReserved!=0 || id.idType!=1 || id.idCount==0) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("ACRt@Cł͂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	for (i=0;i<(int)id.idCount;i++) {
		if (!ReadFile(hFile,&ide,sizeof(ICONDIRENTRY),&dwRead,NULL)
											|| dwRead!=sizeof(ICONDIRENTRY)) {
			CloseHandle(hFile);
			MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
			return FALSE;
		}
		if (Type==ICON_TYPE_UNKNOWN
				|| (Type==ICON_TYPE_BIG && ide.bWidth==32 && ide.bHeight==32)
				|| (Type==ICON_TYPE_SMALL
										&& ide.bWidth==16 && ide.bHeight==16))
			break;
	}
	if (i==(int)id.idCount) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("ACȒ傫Ⴂ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (ide.dwBytesInRes<=sizeof(BITMAPINFOHEADER)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("ACRt@CłB"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (SetFilePointer(hFile,ide.dwImageOffset,NULL,FILE_BEGIN)!=
														ide.dwImageOffset) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@CV[Nł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	*ppbmi=(BITMAPINFO*)MemAlloc(ide.dwBytesInRes);
	if (*ppbmi==NULL) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("mۂł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!ReadFile(hFile,*ppbmi,sizeof(BITMAPINFOHEADER),&dwRead,NULL)
										|| dwRead!=sizeof(BITMAPINFOHEADER)) {
		MemFree(*ppbmi);
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if ((*ppbmi)->bmiHeader.biSize!=sizeof(BITMAPINFOHEADER)
			|| (*ppbmi)->bmiHeader.biHeight<=0
			|| ((*ppbmi)->bmiHeader.biBitCount!=1
				&& (*ppbmi)->bmiHeader.biBitCount!=4
				&& (*ppbmi)->bmiHeader.biBitCount!=8
				&& (*ppbmi)->bmiHeader.biBitCount!=24
				&& (*ppbmi)->bmiHeader.biBitCount!=32)
			|| (*ppbmi)->bmiHeader.biCompression!=BI_RGB) {
		MemFree(*ppbmi);
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("ΉĂȂ`łB"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	DataSize=(DIB_ROW_BYTES((*ppbmi)->bmiHeader.biWidth,
											(*ppbmi)->bmiHeader.biBitCount)+
				DIB_ROW_BYTES((*ppbmi)->bmiHeader.biWidth,1))*
											((*ppbmi)->bmiHeader.biHeight/2);
	if ((*ppbmi)->bmiHeader.biBitCount<=8)
		DataSize+=(1<<(*ppbmi)->bmiHeader.biBitCount)*sizeof(RGBQUAD);
	if (ide.dwBytesInRes<sizeof(BITMAPINFOHEADER)+DataSize) {
		MemFree(*ppbmi);
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("ACRt@CłB"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!ReadFile(hFile,&(*ppbmi)->bmiColors,DataSize,&dwRead,NULL)
														|| dwRead!=DataSize) {
		MemFree(*ppbmi);
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cǂݍ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	CloseHandle(hFile);
	return TRUE;
}


/*
	t@CփACRĕۑ
*/
BOOL SaveIconFile(HWND hwnd,LPCTSTR pszFileName,const BITMAPINFO *pbmiBig,
												const BITMAPINFO *pbmiSmall)
{
	HANDLE hFile;
	DWORD dwWrite;
	ICONDIR id;
	ICONDIRENTRY ide;
	SIZE_T BigIconBytes,SmallIconBytes;

	hFile=CreateFile(pszFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
												FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) {
		MessageBox(hwnd,TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	id.idReserved=0;
	id.idType=1;
	id.idCount=2;
	if (!WriteFile(hFile,&id,sizeof(ICONDIR),&dwWrite,NULL)
												|| dwWrite!=sizeof(ICONDIR)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	BigIconBytes=sizeof(BITMAPINFOHEADER)+
		(DIB_ROW_BYTES(pbmiBig->bmiHeader.biWidth,
												pbmiBig->bmiHeader.biBitCount)+
		DIB_ROW_BYTES(pbmiBig->bmiHeader.biWidth,1))*
											(pbmiBig->bmiHeader.biHeight/2);
	if (pbmiBig->bmiHeader.biBitCount<=8)
		BigIconBytes+=(1<<pbmiBig->bmiHeader.biBitCount)*sizeof(RGBQUAD);
	ide.bWidth=pbmiBig->bmiHeader.biWidth<256?pbmiBig->bmiHeader.biWidth:0;
	ide.bHeight=pbmiBig->bmiHeader.biHeight/2<256?
											pbmiBig->bmiHeader.biHeight/2:0;
	ide.bColorCount=pbmiBig->bmiHeader.biBitCount<=8?
											1<<pbmiBig->bmiHeader.biBitCount:0;
	ide.bReserved=0;
	ide.wPlanes=1;
	ide.wBitCount=pbmiBig->bmiHeader.biBitCount;
	ide.dwBytesInRes=BigIconBytes;
	ide.dwImageOffset=sizeof(ICONDIR)+sizeof(ICONDIRENTRY)*2;
	if (!WriteFile(hFile,&ide,sizeof(ICONDIRENTRY),&dwWrite,NULL)
											|| dwWrite!=sizeof(ICONDIRENTRY)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	SmallIconBytes=sizeof(BITMAPINFOHEADER)+
		(DIB_ROW_BYTES(pbmiSmall->bmiHeader.biWidth,
											pbmiSmall->bmiHeader.biBitCount)+
		DIB_ROW_BYTES(pbmiSmall->bmiHeader.biWidth,1))*
											(pbmiSmall->bmiHeader.biHeight/2);
	if (pbmiSmall->bmiHeader.biBitCount<=8)
		SmallIconBytes+=(1<<pbmiSmall->bmiHeader.biBitCount)*sizeof(RGBQUAD);
	ide.bWidth=pbmiSmall->bmiHeader.biWidth;
	ide.bHeight=pbmiSmall->bmiHeader.biHeight/2;
	ide.bColorCount=pbmiSmall->bmiHeader.biBitCount<=8?
										1<<pbmiSmall->bmiHeader.biBitCount:0;
	ide.bReserved=0;
	ide.wPlanes=1;
	ide.wBitCount=pbmiSmall->bmiHeader.biBitCount;
	ide.dwBytesInRes=SmallIconBytes;
	ide.dwImageOffset=sizeof(ICONDIR)+sizeof(ICONDIRENTRY)*2+BigIconBytes;
	if (!WriteFile(hFile,&ide,sizeof(ICONDIRENTRY),&dwWrite,NULL)
											|| dwWrite!=sizeof(ICONDIRENTRY)) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!WriteFile(hFile,pbmiBig,BigIconBytes,&dwWrite,NULL)
													|| dwWrite!=BigIconBytes) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!WriteFile(hFile,pbmiSmall,SmallIconBytes,&dwWrite,NULL)
												|| dwWrite!=SmallIconBytes) {
		CloseHandle(hFile);
		MessageBox(hwnd,TEXT("t@Cɏ߂܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	CloseHandle(hFile);
	return TRUE;
}


#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL CALLBACK MainDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static BITMAPINFO *pbmiBigIcon=NULL,*pbmiSmallIcon=NULL;
	static HICON hicoCaption;
	static HBITMAP hbmBrowse;

	switch (uMsg) {
	case WM_INITDIALOG:
		{
			LPCTSTR pszCmdLine=(LPCTSTR)lParam;

			SendMessage(hDlg,WM_SETICON,ICON_BIG,
							(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON)));
			hicoCaption=(HICON)LoadImage(hInst,MAKEINTRESOURCE(IDI_ICON),
											IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
			SendMessage(hDlg,WM_SETICON,ICON_SMALL,(LPARAM)hicoCaption);
			hbmBrowse=(HBITMAP)LoadImage(hInst,MAKEINTRESOURCE(IDB_BROWSE),
										IMAGE_BITMAP,16,16,LR_LOADMAP3DCOLORS);
			SendDlgItemMessage(hDlg,IDC_BROWSEBIGICON,BM_SETIMAGE,IMAGE_BITMAP,
															(LPARAM)hbmBrowse);
			SendDlgItemMessage(hDlg,IDC_BROWSESMALLICON,BM_SETIMAGE,
											IMAGE_BITMAP,(LPARAM)hbmBrowse);
			if (pszCmdLine[0]!='\0') {
				LPCTSTR p;
				TCHAR szFileName[MAX_PATH];
				TCHAR Delimiter;
				int i;
				BITMAPINFO *pbmi;

				p=pszCmdLine;
				while (*p!='\0') {
					if (*p=='"') {
						Delimiter='"';
						p++;
					} else
						Delimiter=' ';
					for (i=0;*p!=Delimiter && *p!='\0' && i<MAX_PATH;i++) {
#ifndef UNICODE
						if (IsDBCSLeadByteEx(CP_ACP,*p)) {
							if (i+1==MAX_PATH) {
								i++;
								break;
							}
							szFileName[i++]=*p++;
						}
#endif
						szFileName[i]=*p++;
					}
					if (i==MAX_PATH)
						break;
					szFileName[i]='\0';
					GetLongPathName(szFileName,szFileName,MAX_PATH);
					if (LoadIconFile(hDlg,szFileName,ICON_TYPE_UNKNOWN,&pbmi)) {
						if (pbmi->bmiHeader.biWidth==32) {
							pbmiBigIcon=pbmi;
							SetDlgItemText(hDlg,IDC_BIGICONFILE,szFileName);
							InvalidateRect(GetDlgItem(hDlg,IDC_BIGICON),NULL,
																		TRUE);
						} else if (pbmi->bmiHeader.biWidth==16) {
							pbmiSmallIcon=pbmi;
							SetDlgItemText(hDlg,IDC_SMALLICONFILE,szFileName);
							InvalidateRect(GetDlgItem(hDlg,IDC_SMALLICON),NULL,
																		TRUE);
						} else
							MemFree(pbmi);
					}
					if (pbmiBigIcon!=NULL && pbmiSmallIcon!=NULL) {
						EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
						break;
					}
					if (*p!='\0') {
						p++;
						while (*p==' ')
							p++;
					}
				}
			}
			MoveWindowToCenter(hDlg);
		}
		return TRUE;

	case WM_DROPFILES:
		{
			int i,nFiles;
			TCHAR szFileName[MAX_PATH];
			BITMAPINFO *pbmi;

			SetForegroundWindow(hDlg);
			nFiles=DragQueryFile((HDROP)wParam,0xFFFFFFFF,NULL,0);
			for (i=0;i<nFiles;i++) {
				DragQueryFile((HDROP)wParam,i,szFileName,MAX_PATH);
				if (LoadIconFile(hDlg,szFileName,ICON_TYPE_UNKNOWN,&pbmi)) {
					if (pbmi->bmiHeader.biWidth==32) {
						if (pbmiBigIcon!=NULL)
							MemFree(pbmiBigIcon);
						pbmiBigIcon=pbmi;
						SetDlgItemText(hDlg,IDC_BIGICONFILE,szFileName);
						InvalidateRect(GetDlgItem(hDlg,IDC_BIGICON),NULL,TRUE);
					} else if (pbmi->bmiHeader.biWidth==16) {
						if (pbmiSmallIcon!=NULL)
							MemFree(pbmiSmallIcon);
						pbmiSmallIcon=pbmi;
						SetDlgItemText(hDlg,IDC_SMALLICONFILE,szFileName);
						InvalidateRect(GetDlgItem(hDlg,IDC_SMALLICON),NULL,
																		TRUE);
					} else {
						MessageBox(hDlg,TEXT("ACȒ傫słB"),
											NULL,MB_OK | MB_ICONEXCLAMATION);
						MemFree(pbmi);
					}
				}
			}
			DragFinish((HDROP)wParam);
			if (pbmiBigIcon!=NULL && pbmiSmallIcon!=NULL)
				EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
		}
		return TRUE;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;
			HBRUSH hbr;
			BITMAPINFO *pbmi;
			int Width,Height;
			int x,y;
			SIZE_T InfoSize;
			BITMAPINFO8 bmi;

			hbr=CreateSolidBrush(GetSysColor(COLOR_3DFACE));
			FillRect(pdis->hDC,&pdis->rcItem,hbr);
			DeleteObject(hbr);
			if (pdis->CtlID==IDC_BIGICON) {
				if (pbmiBigIcon==NULL)
					return TRUE;
				pbmi=pbmiBigIcon;
			} else {
				if (pbmiSmallIcon==NULL)
					return TRUE;
				pbmi=pbmiSmallIcon;
			}
			Width=pbmi->bmiHeader.biWidth;
			Height=pbmi->bmiHeader.biHeight/2;
			x=pdis->rcItem.left+((pdis->rcItem.right-pdis->rcItem.left)-Width)/
																			2;
			y=pdis->rcItem.top+((pdis->rcItem.bottom-pdis->rcItem.top)-Height)/
																			2;
			InfoSize=sizeof(BITMAPINFOHEADER);
			if (pbmi->bmiHeader.biBitCount<=8)
				InfoSize+=(1<<pbmi->bmiHeader.biBitCount)*sizeof(RGBQUAD);
			bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
			bmi.bmiHeader.biWidth=Width;
			bmi.bmiHeader.biHeight=Height;
			bmi.bmiHeader.biPlanes=1;
			bmi.bmiHeader.biBitCount=1;
			bmi.bmiHeader.biCompression=BI_RGB;
			bmi.bmiHeader.biSizeImage=0;
			bmi.bmiHeader.biXPelsPerMeter=0;
			bmi.bmiHeader.biYPelsPerMeter=0;
			bmi.bmiHeader.biClrUsed=0;
			bmi.bmiHeader.biClrImportant=0;
			bmi.bmiColors[0].rgbBlue=0;
			bmi.bmiColors[0].rgbGreen=0;
			bmi.bmiColors[0].rgbRed=0;
			bmi.bmiColors[0].rgbReserved=0;
			bmi.bmiColors[1].rgbBlue=255;
			bmi.bmiColors[1].rgbGreen=255;
			bmi.bmiColors[1].rgbRed=255;
			bmi.bmiColors[1].rgbReserved=0;
			StretchDIBits(pdis->hDC,x,y,Width,Height,0,0,Width,Height,
				(BYTE*)pbmi+InfoSize+
						DIB_ROW_BYTES(Width,pbmi->bmiHeader.biBitCount)*Height,
									(BITMAPINFO*)&bmi,DIB_RGB_COLORS,SRCAND);
			CopyMemory(&bmi,pbmi,InfoSize);
			bmi.bmiHeader.biHeight/=2;
			StretchDIBits(pdis->hDC,x,y,Width,Height,0,0,Width,Height,
						(BYTE*)pbmi+InfoSize,(BITMAPINFO*)&bmi,DIB_RGB_COLORS,
																	SRCINVERT);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BROWSEBIGICON:
			{
				OPENFILENAME ofn;
				TCHAR szText[MAX_PATH],szFileName[MAX_PATH];

				GetDlgItemText(hDlg,IDC_BIGICONFILE,szText,MAX_PATH);
				if (szText[0]!='\0')
					lstrcpy(szFileName,PathFindFileName(szText));
				else
					szFileName[0]='\0';
#if _WIN32_WINNT>=0x0500
				ofn.lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
				ofn.lStructSize=sizeof(OPENFILENAME);
#endif
				ofn.hwndOwner=hDlg;
				ofn.lpstrFilter=pszFileFilter;
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=MAX_PATH;
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=TEXT("傫ACR");
				ofn.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
				ofn.lpstrDefExt=NULL;
				if (GetOpenFileName(&ofn)) {
					BITMAPINFO *pbmi;

					if (LoadIconFile(hDlg,szFileName,ICON_TYPE_BIG,&pbmi)) {
						if (pbmiBigIcon!=NULL)
							MemFree(pbmiBigIcon);
						pbmiBigIcon=pbmi;
						SetDlgItemText(hDlg,IDC_BIGICONFILE,szFileName);
						InvalidateRect(GetDlgItem(hDlg,IDC_BIGICON),NULL,TRUE);
						if (pbmiSmallIcon!=NULL)
							EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
					}
				}
			}
			return TRUE;

		case IDC_BROWSESMALLICON:
			{
				OPENFILENAME ofn;
				TCHAR szText[MAX_PATH],szFileName[MAX_PATH];

				GetDlgItemText(hDlg,IDC_SMALLICONFILE,szText,MAX_PATH);
				if (szText[0]!='\0')
					lstrcpy(szFileName,PathFindFileName(szText));
				else
					szFileName[0]='\0';
#if _WIN32_WINNT>=0x0500
				ofn.lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
				ofn.lStructSize=sizeof(OPENFILENAME);
#endif
				ofn.hwndOwner=hDlg;
				ofn.lpstrFilter=pszFileFilter;
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=MAX_PATH;
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=TEXT("ACR");
				ofn.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
				ofn.lpstrDefExt=NULL;
				if (GetOpenFileName(&ofn)) {
					BITMAPINFO *pbmi;

					if (LoadIconFile(hDlg,szFileName,ICON_TYPE_SMALL,&pbmi)) {
						if (pbmiSmallIcon!=NULL)
							MemFree(pbmiSmallIcon);
						pbmiSmallIcon=pbmi;
						SetDlgItemText(hDlg,IDC_SMALLICONFILE,szFileName);
						InvalidateRect(GetDlgItem(hDlg,IDC_SMALLICON),NULL,
																		TRUE);
						if (pbmiBigIcon!=NULL)
							EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
					}
				}
			}
			return TRUE;

		case IDOK:
			if (pbmiBigIcon!=NULL && pbmiSmallIcon!=NULL) {
				OPENFILENAME ofn;
				TCHAR szFileName[MAX_PATH];

				szFileName[0]='\0';
#if _WIN32_WINNT>=0x0500
				ofn.lStructSize=OPENFILENAME_SIZE_VERSION_400;
#else
				ofn.lStructSize=sizeof(OPENFILENAME);
#endif
				ofn.hwndOwner=hDlg;
				ofn.lpstrFilter=pszFileFilter;
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=MAX_PATH;
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=NULL;
				ofn.Flags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
				ofn.lpstrDefExt=TEXT("ico");
				if (GetSaveFileName(&ofn)) {
					HCURSOR hcurOld;

					hcurOld=SetCursor(LoadCursor(NULL,IDC_WAIT));
					SaveIconFile(hDlg,szFileName,pbmiBigIcon,pbmiSmallIcon);
					SetCursor(hcurOld);
				}
			}
			return TRUE;

		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
		}
		return TRUE;

	case WM_DESTROY:
		DestroyIcon(hicoCaption);
		DeleteObject(hbmBrowse);
		if (pbmiBigIcon!=NULL)
			MemFree(pbmiBigIcon);
		if (pbmiSmallIcon!=NULL)
			MemFree(pbmiSmallIcon);
		return TRUE;
	}
	return FALSE;
}


#ifdef __BORLANDC__
#pragma argsused
#endif
int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
												LPTSTR pszCmdLine,int nCmdShow)
{
	hInst=hInstance;
	DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_MAIN),NULL,MainDlgProc,
														(LPARAM)pszCmdLine);
	return 0;
}
